OGRE: Ogre::PatchMesh Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes

# Ogre::PatchMesh Class Reference
[LOD]

Patch specialisation of Mesh. More...

`#include <OgrePatchMesh.h>`

Inheritance diagram for Ogre::PatchMesh:
[legend]

List of all members.

## Public Types
typedef vector< Real >::type | LodValueList
typedef vector< MeshLodUsage > ::type | MeshLodUsageList
typedef multimap< size_t, VertexBoneAssignment >::type | VertexBoneAssignmentList
| Multimap of vertex bone assignments (orders by vertex index).
typedef MapIterator < VertexBoneAssignmentList > | BoneAssignmentIterator
typedef vector< SubMesh * >::type | SubMeshList
typedef vector< unsigned short > ::type | IndexMap
typedef HashMap< String, ushort > | SubMeshNameMap
| A hashmap used to store optional SubMesh names.
typedef VectorIterator < SubMeshList > | SubMeshIterator
typedef VectorIterator< PoseList > | PoseIterator
typedef ConstVectorIterator < PoseList > | ConstPoseIterator
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| PatchMesh (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group)
| Constructor.
void | define (void *controlPointBuffer, VertexDeclaration *declaration, size_t width, size_t height, size_t uMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, size_t vMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, PatchSurface::VisibleSide visibleSide=PatchSurface::VS_FRONT, HardwareBuffer::Usage vbUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage ibUsage=HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY, bool vbUseShadow=false, bool ibUseShadow=false)
| Define the patch, as defined in MeshManager::createBezierPatch.
void | setSubdivision (Real factor)
SubMesh * | createSubMesh (void)
| Creates a new SubMesh.
SubMesh * | createSubMesh (const String &name)
| Creates a new SubMesh and gives it a name.
void | nameSubMesh (const String &name, ushort index)
| Gives a name to a SubMesh.
void | unnameSubMesh (const String &name)
| Removes a name from a SubMesh.
ushort | _getSubMeshIndex (const String &name) const
| Gets the index of a submesh with a given name.
unsigned short | getNumSubMeshes (void) const
| Gets the number of sub meshes which comprise this mesh.
SubMesh * | getSubMesh (unsigned short index) const
| Gets a pointer to the submesh indicated by the index.
SubMesh * | getSubMesh (const String &name) const
| Gets a SubMesh by name.
void | destroySubMesh (unsigned short index)
| Destroy a SubMesh with the given index.
void | destroySubMesh (const String &name)
| Destroy a SubMesh with the given name.
SubMeshIterator | getSubMeshIterator (void)
| Gets an iterator over the available submeshes.
MeshPtr | clone (const String &newName, const String &newGroup=StringUtil::BLANK)
| Makes a copy of this mesh object and gives it a new name.
const AxisAlignedBox & | getBounds (void) const
| Get the axis-aligned bounding box for this mesh.
Real | getBoundingSphereRadius (void) const
| Gets the radius of the bounding sphere surrounding this mesh.
void | _setBounds (const AxisAlignedBox &bounds, bool pad=true)
| Manually set the bounding box for this Mesh.
void | _setBoundingSphereRadius (Real radius)
| Manually set the bounding radius.
void | setSkeletonName (const String &skelName)
| Sets the name of the skeleton this Mesh uses for animation.
bool | hasSkeleton (void) const
| Returns true if this Mesh has a linked Skeleton.
bool | hasVertexAnimation (void) const
| Returns whether or not this mesh has some kind of vertex animation.
const SkeletonPtr & | getSkeleton (void) const
| Gets a pointer to any linked Skeleton.
const String & | getSkeletonName (void) const
| Gets the name of any linked Skeleton.
void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this mesh.
void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this mesh.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh.
void | _notifySkeleton (SkeletonPtr &pSkel)
| Internal notification, used to tell the Mesh which Skeleton to use without loading it.
BoneAssignmentIterator | getBoneAssignmentIterator (void)
| Gets an iterator for access all bone assignments.
const VertexBoneAssignmentList & | getBoneAssignments () const
| Gets a const reference to the list of bone assignments.
void | generateLodLevels (const LodValueList &lodValues, ProgressiveMesh::VertexReductionQuota reductionMethod, Real reductionValue)
| Automatically generates lower level of detail versions of this mesh for use when a simpler version of the model is acceptable for rendering.
ushort | getNumLodLevels (void) const
| Returns the number of levels of detail that this mesh supports.
const MeshLodUsage & | getLodLevel (ushort index) const
| Gets details of the numbered level of detail entry.
void | createManualLodLevel (Real value, const String &meshName, const String &groupName=Ogre::String())
| Adds a new manual level-of-detail entry to this Mesh.
void | updateManualLodLevel (ushort index, const String &meshName)
| Changes the alternate mesh to use as a manual LOD at the given index.
ushort | getLodIndex (Real value) const
| Retrieves the level of detail index for the given lod value.
bool | isLodManual (void) const
| Returns true if this mesh is using manual LOD.
void | _setLodInfo (unsigned short numLevels, bool isManual)
| Internal methods for loading LOD, do not use.
void | _setLodUsage (unsigned short level, MeshLodUsage &usage)
| Internal methods for loading LOD, do not use.
void | _setSubMeshLodFaceList (unsigned short subIdx, unsigned short level, IndexData *facedata)
| Internal methods for loading LOD, do not use.
void | removeLodLevels (void)
| Removes all LOD data from this Mesh.
void | setVertexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the vertex buffers to be used when loading this Mesh.
void | setIndexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the index buffers to be used when loading this Mesh.
HardwareBuffer::Usage | getVertexBufferUsage (void) const
| Gets the usage setting for this meshes vertex buffers.
HardwareBuffer::Usage | getIndexBufferUsage (void) const
| Gets the usage setting for this meshes index buffers.
bool | isVertexBufferShadowed (void) const
| Gets whether or not this meshes vertex buffers are shadowed.
bool | isIndexBufferShadowed (void) const
| Gets whether or not this meshes index buffers are shadowed.
unsigned short | _rationaliseBoneAssignments (size_t vertexCount, VertexBoneAssignmentList &assignments)
| Rationalises the passed in bone assignment list.
void | _compileBoneAssignments (void)
| Internal method, be called once to compile bone assignments into geometry buffer.
void | _updateCompiledBoneAssignments (void)
| Internal method, be called once to update the compiled bone assignments.
void | buildTangentVectors (VertexElementSemantic targetSemantic=VES_TANGENT, unsigned short sourceTexCoordSet=0, unsigned short index=0, bool splitMirrored=false, bool splitRotated=false, bool storeParityInW=false)
| This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.
bool | suggestTangentVectorBuildParams (VertexElementSemantic targetSemantic, unsigned short &outSourceCoordSet, unsigned short &outIndex)
| Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents.
void | buildEdgeList (void)
| Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.
void | freeEdgeList (void)
| Destroys and frees the edge lists this mesh has built.
void | prepareForShadowVolume (void)
| This method prepares the mesh for generating a renderable shadow volume.
EdgeData * | getEdgeList (unsigned short lodIndex=0)
| Return the edge list for this mesh, building it if required.
const EdgeData * | getEdgeList (unsigned short lodIndex=0) const
| Return the edge list for this mesh, building it if required.
bool | isPreparedForShadowVolumes (void) const
| Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.
bool | isEdgeListBuilt (void) const
| Returns whether this mesh has an attached edge list.
const SubMeshNameMap & | getSubMeshNameMap (void) const
| Gets a reference to the optional name assignments of the SubMeshes.
void | setAutoBuildEdgeLists (bool autobuild)
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
bool | getAutoBuildEdgeLists (void) const
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
virtual VertexAnimationType | getSharedVertexDataAnimationType (void) const
| Gets the type of vertex animation the shared vertex data of this mesh supports.
virtual Animation * | createAnimation (const String &name, Real length)
| Creates a new Animation object for vertex animating this mesh.
virtual Animation * | getAnimation (const String &name) const
| Returns the named vertex Animation object.
virtual Animation * | getAnimation (unsigned short index) const
| Gets a single morph animation by index.
virtual Animation * | _getAnimationImpl (const String &name) const
| Internal access to the named vertex Animation object - returns null if it does not exist.
virtual bool | hasAnimation (const String &name)
| Returns whether this mesh contains the named vertex animation.
virtual void | removeAnimation (const String &name)
| Removes vertex Animation from this mesh.
virtual unsigned short | getNumAnimations (void) const
| Gets the number of morph animations in this mesh.
virtual void | removeAllAnimations (void)
| Removes all morph Animations from this mesh.
VertexData * | getVertexDataByTrackHandle (unsigned short handle)
| Gets a pointer to a vertex data element based on a morph animation track handle.
void | updateMaterialForAllSubMeshes (void)
| Iterates through all submeshes and requests them to apply their texture aliases to the material they use.
void | _determineAnimationTypes (void) const
| Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).
bool | _getAnimationTypesDirty (void) const
| Are the derived animation types out of date?
Pose * | createPose (ushort target, const String &name=StringUtil::BLANK)
| Create a new Pose for this mesh or one of its submeshes.
size_t | getPoseCount (void) const
| Get the number of poses.
Pose * | getPose (ushort index)
| Retrieve an existing Pose by index.
Pose * | getPose (const String &name)
| Retrieve an existing Pose by name.
void | removePose (ushort index)
| Destroy a pose by index.
void | removePose (const String &name)
| Destroy a pose by name.
void | removeAllPoses (void)
| Destroy all poses.
PoseIterator | getPoseIterator (void)
| Get an iterator over all the poses defined.
ConstPoseIterator | getPoseIterator (void) const
| Get an iterator over all the poses defined.
const PoseList & | getPoseList (void) const
| Get pose list.
const LodStrategy * | getLodStrategy () const
| Get lod strategy used by this mesh.
void | setLodStrategy (LodStrategy *lodStrategy)
| Set the lod strategy used by this mesh.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual const String & | getName (void) const
| Gets resource name.
virtual ResourceHandle | getHandle (void) const
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual const String & | getGroup (void)
| Gets the group which this resource is a member of.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | prepareMatricesForVertexBlend (const Matrix4 **blendMatrices, const Matrix4 *boneMatrices, const IndexMap &indexMap)
| Prepare matrices for software indexed vertex blend.
static void | softwareVertexBlend (const VertexData *sourceVertexData, const VertexData *targetVertexData, const Matrix4 *const *blendMatrices, size_t numMatrices, bool blendNormals)
| Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.
static void | softwareVertexMorph (Real t, const HardwareVertexBufferSharedPtr &b1, const HardwareVertexBufferSharedPtr &b2, VertexData *targetVertexData)
| Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.
static void | softwareVertexPoseBlend (Real weight, const map< size_t, Vector3 >::type &vertexOffsetMap, VertexData *targetVertexData)
| Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Public Attributes
VertexData * | sharedVertexData
| Shared vertex data.
IndexMap | sharedBlendIndexToBoneIndexMap
| Shared index map for translating blend index to bone index.
## Protected Types
typedef map< String, Animation * > ::type | AnimationList
| Storage of morph animations, lookup by name.
typedef list< Listener * >::type | ListenerList
## Protected Member Functions
void | loadImpl (void)
| Overridden from Resource.
void | prepareImpl (void)
| Overridden from Resource - do nothing (no disk caching).
void | organiseTangentsBuffer (VertexData *vertexData, VertexElementSemantic targetSemantic, unsigned short index, unsigned short sourceTexCoordSet)
| Internal method for making the space for a vertex element to hold tangents.
void | buildIndexMap (const VertexBoneAssignmentList &boneAssignments, IndexMap &boneIndexToBlendIndexMap, IndexMap &blendIndexToBoneIndexMap)
| Build the index map between bone index and blend index.
void | compileBoneAssignments (const VertexBoneAssignmentList &boneAssignments, unsigned short numBlendWeightsPerVertex, IndexMap &blendIndexToBoneIndexMap, VertexData *targetVertexData)
| Compile bone assignments into blend index and weight buffers.
void | unprepareImpl (void)
| Destroys data cached by prepareImpl.
void | postLoadImpl (void)
void | unloadImpl (void)
size_t | calculateSize (void) const
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
PatchSurface | mSurface
| Internal surface definition.
VertexDeclaration * | mDeclaration
| Vertex declaration, cloned from the input.
SubMeshList | mSubMeshList
| A list of submeshes which make up this mesh.
DataStreamPtr | mFreshFromDisk
SubMeshNameMap | mSubMeshNameMap
AxisAlignedBox | mAABB
| Local bounding box volume.
Real | mBoundRadius
| Local bounding sphere radius (centered on object).
String | mSkeletonName
| Optional linked skeleton.
SkeletonPtr | mSkeleton
VertexBoneAssignmentList | mBoneAssignments
bool | mBoneAssignmentsOutOfDate
| Flag indicating that bone assignments need to be recompiled.
const LodStrategy * | mLodStrategy
bool | mIsLodManual
ushort | mNumLods
MeshLodUsageList | mMeshLodUsageList
HardwareBuffer::Usage | mVertexBufferUsage
HardwareBuffer::Usage | mIndexBufferUsage
bool | mVertexBufferShadowBuffer
bool | mIndexBufferShadowBuffer
bool | mPreparedForShadowVolumes
bool | mEdgeListsBuilt
bool | mAutoBuildEdgeLists
AnimationList | mAnimationsList
VertexAnimationType | mSharedVertexDataAnimationType
| The vertex animation type associated with the shared vertex data.
bool | mAnimationTypesDirty
| Do we need to scan animations for animation types?
PoseList | mPoseList
| List of available poses for shared and dedicated geometryPoseList.
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
AtomicScalar< LoadingState > | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
size_t | mStateCount
| State count, the number of times this resource has changed state.
ListenerList | mListenerList

## Detailed Description

Patch specialisation of Mesh.

Remarks:
  Instances of this class should be created by calling MeshManager::createBezierPatch.

Definition at line 47 of file OgrePatchMesh.h.

## Member Typedef Documentation

typedef map<String, Animation*>::type Ogre::Mesh::AnimationList`[protected, inherited]`

Storage of morph animations, lookup by name.

Definition at line 175 of file OgreMesh.h.

typedef MapIterator<VertexBoneAssignmentList> Ogre::Mesh::BoneAssignmentIterator`[inherited]`

Definition at line 104 of file OgreMesh.h.

typedef ConstVectorIterator<PoseList> Ogre::Mesh::ConstPoseIterator`[inherited]`

Definition at line 872 of file OgreMesh.h.

typedef vector<unsigned short>::type Ogre::Mesh::IndexMap`[inherited]`

Definition at line 106 of file OgreMesh.h.

typedef list<Listener*>::type Ogre::Resource::ListenerList`[protected, inherited]`

Definition at line 164 of file OgreResource.h.

typedef vector<Real>::type Ogre::Mesh::LodValueList`[inherited]`

Definition at line 100 of file OgreMesh.h.

typedef vector<MeshLodUsage>::type Ogre::Mesh::MeshLodUsageList`[inherited]`

Definition at line 101 of file OgreMesh.h.

typedef VectorIterator<PoseList> Ogre::Mesh::PoseIterator`[inherited]`

Definition at line 871 of file OgreMesh.h.

typedef VectorIterator<SubMeshList> Ogre::Mesh::SubMeshIterator`[inherited]`

Definition at line 271 of file OgreMesh.h.

typedef vector<SubMesh*>::type Ogre::Mesh::SubMeshList`[inherited]`

Definition at line 105 of file OgreMesh.h.

typedef HashMap<String, ushort> Ogre::Mesh::SubMeshNameMap`[inherited]`

A hashmap used to store optional SubMesh names.

Translates a name into SubMesh index

Definition at line 126 of file OgreMesh.h.

typedef multimap<size_t, VertexBoneAssignment>::type Ogre::Mesh::VertexBoneAssignmentList`[inherited]`

Multimap of vertex bone assignments (orders by vertex index).

Definition at line 103 of file OgreMesh.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumerator:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
  LOADSTATE_PREPARED | Fully prepared.
  LOADSTATE_PREPARING | Preparing is in progress.

Definition at line 125 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::PatchMesh::PatchMesh | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group |
| ) |  |  |

Constructor.

## Member Function Documentation

void Ogre::Mesh::_compileBoneAssignments | ( | void |  | ) | `[inherited]`

Internal method, be called once to compile bone assignments into geometry buffer.

Remarks:
  The OGRE engine calls this method automatically. It compiles the information submitted as bone assignments into a format usable in realtime. It also eliminates excessive bone assignments (max is OGRE_MAX_BLEND_WEIGHTS) and re-normalises the remaining assignments.

void Ogre::Mesh::_determineAnimationTypes | ( | void |  | ) | const`[inherited]`

Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).

virtual void Ogre::Resource::_dirtyState | ( |  | ) | `[virtual, inherited]`

Manually mark the state of this resource as having been changed.

Remarks:
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also:
  getStateCount.

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of preparing complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of unloading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

virtual Animation* Ogre::Mesh::_getAnimationImpl | ( | const String & | name | ) | const`[virtual, inherited]`

Internal access to the named vertex Animation object - returns null if it does not exist.

Parameters:

  | name | The name of the animation

bool Ogre::Mesh::_getAnimationTypesDirty | ( | void |  | ) | const`[inherited]`

Are the derived animation types out of date?

Definition at line 845 of file OgreMesh.h.

ushort Ogre::Mesh::_getSubMeshIndex | ( | const String & | name | ) | const`[inherited]`

Gets the index of a submesh with a given name.

Remarks:
  Useful if you identify the SubMeshes by name (using nameSubMesh) but wish to have faster repeat access.

void Ogre::Mesh::_initAnimationState | ( | AnimationStateSet * | animSet | ) | `[inherited]`

Initialise an animation set suitable for use with this mesh.

Remarks:
  Only recommended for use inside the engine, not by applications.

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[virtual, inherited]`

Notify this resource of it's origin.

Definition at line 420 of file OgreResource.h.

void Ogre::Mesh::_notifySkeleton | ( | SkeletonPtr & | pSkel | ) | `[inherited]`

Internal notification, used to tell the Mesh which Skeleton to use without loading it.

Remarks:
  This is only here for unusual situation where you want to manually set up a Skeleton. Best to let OGRE deal with this, don't call it yourself unless you really know what you're doing.

unsigned short Ogre::Mesh::_rationaliseBoneAssignments | ( | size_t | vertexCount,
|  | VertexBoneAssignmentList & | assignments |
| ) |  |  | `[inherited]`

Rationalises the passed in bone assignment list.

Remarks:
  OGRE supports up to 4 bone assignments per vertex. The reason for this limit is that this is the maximum number of assignments that can be passed into a hardware-assisted blending algorithm. This method identifies where there are more than 4 bone assignments for a given vertex, and eliminates the bone assignments with the lowest weights to reduce to this limit. The remaining weights are then re-balanced to ensure that they sum to 1.0.

Parameters:

  | vertexCount | The number of vertices.
  | assignments | The bone assignment list to rationalise. This list will be modified and entries will be removed where the limits are exceeded.

Returns:
  The maximum number of bone assignments per vertex found, clamped to [1-4]

void Ogre::Mesh::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) | `[inherited]`

Refresh an animation set suitable for use with this mesh.

Remarks:
  Only recommended for use inside the engine, not by applications.

void Ogre::Mesh::_setBoundingSphereRadius | ( | Real | radius | ) | `[inherited]`

Manually set the bounding radius.

Remarks:
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

void Ogre::Mesh::_setBounds | ( | const AxisAlignedBox & | bounds,
|  | bool | pad = `true` |
| ) |  |  | `[inherited]`

Manually set the bounding box for this Mesh.

Remarks:
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

Parameters:

  | pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

void Ogre::Mesh::_setLodInfo | ( | unsigned short | numLevels,
|  | bool | isManual |
| ) |  |  | `[inherited]`

Internal methods for loading LOD, do not use.

void Ogre::Mesh::_setLodUsage | ( | unsigned short | level,
|  | MeshLodUsage & | usage |
| ) |  |  | `[inherited]`

Internal methods for loading LOD, do not use.

void Ogre::Mesh::_setSubMeshLodFaceList | ( | unsigned short | subIdx,
|  | unsigned short | level,
|  | IndexData * | facedata |
| ) |  |  | `[inherited]`

Internal methods for loading LOD, do not use.

void Ogre::Mesh::_updateCompiledBoneAssignments | ( | void |  | ) | `[inherited]`

Internal method, be called once to update the compiled bone assignments.

Remarks:
  The OGRE engine calls this method automatically. It updates the compiled bone assignments if requested.

void Ogre::Mesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) | `[inherited]`

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks:
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Mesh::buildEdgeList | ( | void |  | ) | `[inherited]`

Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.

void Ogre::Mesh::buildIndexMap | ( | const VertexBoneAssignmentList & | boneAssignments,
|  | IndexMap & | boneIndexToBlendIndexMap,
|  | IndexMap & | blendIndexToBoneIndexMap |
| ) |  |  | `[protected, inherited]`

Build the index map between bone index and blend index.

void Ogre::Mesh::buildTangentVectors | ( | VertexElementSemantic | targetSemantic = `VES_TANGENT`,
|  | unsigned short | sourceTexCoordSet = `0`,
|  | unsigned short | index = `0`,
|  | bool | splitMirrored = `false`,
|  | bool | splitRotated = `false`,
|  | bool | storeParityInW = `false` |
| ) |  |  | `[inherited]`

This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.

Remarks:
  Tangent vectors are vectors representing the local 'X' axis for a given vertex based on the orientation of the 2D texture on the geometry. They are built from a combination of existing normals, and from the 2D texture coordinates already baked into the model. They can be used for a number of things, but most of all they are useful for vertex and fragment programs, when you wish to arrive at a common space for doing per-pixel calculations.

  The prerequisites for calling this method include that the vertex data used by every SubMesh has both vertex normals and 2D texture coordinates.

Parameters:

  | targetSemantic | The semantic to store the tangents in. Defaults to the explicit tangent binding, but note that this is only usable on more modern hardware (Shader Model 2), so if you need portability with older cards you should change this to a texture coordinate binding instead.
  | sourceTexCoordSet | The texture coordinate index which should be used as the source of 2D texture coordinates, with which to calculate the tangents.
  | index | The element index, ie the texture coordinate set which should be used to store the 3D coordinates representing a tangent vector per vertex, if targetSemantic is VES_TEXTURE_COORDINATES. If this already exists, it will be overwritten.
  | splitMirrored | Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs).

See also:
  TangentSpaceCalc::setSplitMirrored

Parameters:

  | splitRotated | Sets whether or not to split vertices when a rotated tangent space is detected.

See also:
  TangentSpaceCalc::setSplitRotated

Parameters:

  | storeParityInW | If true, store tangents as a 4-vector and include parity in w

size_t Ogre::Mesh::calculateSize | ( | void |  | ) | const`[protected, virtual, inherited]`

Calculate the size of a resource; this will only be called after 'load'.

Implements Ogre::Resource.

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[virtual, inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

void Ogre::Mesh::clearBoneAssignments | ( | void |  | ) | `[inherited]`

Removes all bone assignments for this mesh.

Remarks:
  This method is for modifying weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

MeshPtr Ogre::Mesh::clone | ( | const String & | newName,
|  | const String & | newGroup = `StringUtil::BLANK` |
| ) |  |  | `[inherited]`

Makes a copy of this mesh object and gives it a new name.

Remarks:
  This is useful if you want to tweak an existing mesh without affecting the original one. The newly cloned mesh is registered with the MeshManager under the new name.

Parameters:

  | newName | The name to give the clone
  | newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Mesh.

void Ogre::Mesh::compileBoneAssignments | ( | const VertexBoneAssignmentList & | boneAssignments,
|  | unsigned short | numBlendWeightsPerVertex,
|  | IndexMap & | blendIndexToBoneIndexMap,
|  | VertexData * | targetVertexData |
| ) |  |  | `[protected, inherited]`

Compile bone assignments into blend index and weight buffers.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

virtual Animation* Ogre::Mesh::createAnimation | ( | const String & | name,
|  | Real | length |
| ) |  |  | `[virtual, inherited]`

Creates a new Animation object for vertex animating this mesh.

Parameters:

  | name | The name of this animation
  | length | The length of the animation in seconds

void Ogre::Mesh::createManualLodLevel | ( | Real | value,
|  | const String & | meshName,
|  | const String & | groupName = `Ogre::String()` |
| ) |  |  | `[inherited]`

Adds a new manual level-of-detail entry to this Mesh.

Remarks:
  As an alternative to generating lower level of detail versions of a mesh, you can use your own manually modelled meshes as lower level versions. This lets you have complete control over the LOD, and in addition lets you scale down other aspects of the model which cannot be done using the generated method; for example, you could use less detailed materials and / or use less bones in the skeleton if this is an animated mesh. Therefore for complex models you are likely to be better off modelling your LODs yourself and using this method, whilst for models with fairly simple materials and no animation you can just use the generateLodLevels method.

Parameters:

  | value | The value from which this Lod will apply.
  | meshName | The name of the mesh which will be the lower level detail version.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

Pose* Ogre::Mesh::createPose | ( | ushort | target,
|  | const String & | name = `StringUtil::BLANK` |
| ) |  |  | `[inherited]`

Create a new Pose for this mesh or one of its submeshes.

Parameters:

  | target | The target geometry index; 0 is the shared Mesh geometry, 1+ is the dedicated SubMesh geometry belonging to submesh index + 1.
  | name | Name to give the pose, which is optional

Returns:
  A new Pose ready for population

SubMesh* Ogre::Mesh::createSubMesh | ( | const String & | name | ) | `[inherited]`

Creates a new SubMesh and gives it a name.

SubMesh* Ogre::Mesh::createSubMesh | ( | void |  | ) | `[inherited]`

Creates a new SubMesh.

Remarks:
  Method for manually creating geometry for the mesh. Note - use with extreme caution - you must be sure that you have set up the geometry properly.

void Ogre::PatchMesh::define | ( | void * | controlPointBuffer,
|  | VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | size_t | vMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | PatchSurface::VisibleSide | visibleSide = `PatchSurface::VS_FRONT`,
|  | HardwareBuffer::Usage | vbUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | ibUsage = `HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY`,
|  | bool | vbUseShadow = `false`,
|  | bool | ibUseShadow = `false` |
| ) |  |  |

Define the patch, as defined in MeshManager::createBezierPatch.

void Ogre::Mesh::destroySubMesh | ( | const String & | name | ) | `[inherited]`

Destroy a SubMesh with the given name.

Note:
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

void Ogre::Mesh::destroySubMesh | ( | unsigned short | index | ) | `[inherited]`

Destroy a SubMesh with the given index.

Note:
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

virtual void Ogre::Resource::escalateLoading | ( |  | ) | `[virtual, inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Mesh::freeEdgeList | ( | void |  | ) | `[inherited]`

Destroys and frees the edge lists this mesh has built.

void Ogre::Mesh::generateLodLevels | ( | const LodValueList & | lodValues,
|  | ProgressiveMesh::VertexReductionQuota | reductionMethod,
|  | Real | reductionValue |
| ) |  |  | `[inherited]`

Automatically generates lower level of detail versions of this mesh for use when a simpler version of the model is acceptable for rendering.

Remarks:
  There are 2 ways that you can create level-of-detail (LOD) versions of a mesh; the first is to call this method, which does fairly extensive calculations to work out how to simplify the mesh whilst having the minimum affect on the model. The alternative is to actually create simpler versions of the mesh yourself in a modelling tool, and having exported them, tell the 'master' mesh to use these alternative meshes for lower detail versions; this is done by calling the createManualLodLevel method.

  As well as creating the lower detail versions of the mesh, this method will also associate them with depth values. As soon as an object is at least as far away from the camera as the depth value associated with it's LOD, it will drop to that level of detail.

  I recommend calling this method before mesh export, not at runtime.

Parameters:

  | lodValues | A list of lod values indicating the values at which new lods should be generated. These are 'user values', before being potentially transformed by the strategy, so for the distance strategy this is an unsquared distance for example.
  | reductionMethod | The way to determine the number of vertices collapsed per LOD
  | reductionValue | Meaning depends on reductionMethod, typically either the proportion of remaining vertices to collapse or a fixed number of vertices.

virtual Animation* Ogre::Mesh::getAnimation | ( | const String & | name | ) | const`[virtual, inherited]`

Returns the named vertex Animation object.

Parameters:

  | name | The name of the animation

virtual Animation* Ogre::Mesh::getAnimation | ( | unsigned short | index | ) | const`[virtual, inherited]`

Gets a single morph animation by index.

bool Ogre::Mesh::getAutoBuildEdgeLists | ( | void |  | ) | const`[inherited]`

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

Definition at line 782 of file OgreMesh.h.

BoneAssignmentIterator Ogre::Mesh::getBoneAssignmentIterator | ( | void |  | ) | `[inherited]`

Gets an iterator for access all bone assignments.

const VertexBoneAssignmentList& Ogre::Mesh::getBoneAssignments | ( |  | ) | const`[inherited]`

Gets a const reference to the list of bone assignments.

Definition at line 418 of file OgreMesh.h.

Real Ogre::Mesh::getBoundingSphereRadius | ( | void |  | ) | const`[inherited]`

Gets the radius of the bounding sphere surrounding this mesh.

const AxisAlignedBox& Ogre::Mesh::getBounds | ( | void |  | ) | const`[inherited]`

Get the axis-aligned bounding box for this mesh.

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[virtual, inherited]`

Gets the manager which created this resource.

Definition at line 411 of file OgreResource.h.

EdgeData* Ogre::Mesh::getEdgeList | ( | unsigned short | lodIndex = `0` | ) | `[inherited]`

Return the edge list for this mesh, building it if required.

Remarks:
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose. The LOD at which to get the edge list, 0 being the highest.

const EdgeData* Ogre::Mesh::getEdgeList | ( | unsigned short | lodIndex = `0` | ) | const`[inherited]`

Return the edge list for this mesh, building it if required.

Remarks:
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose. The LOD at which to get the edge list, 0 being the highest.

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | `[virtual, inherited]`

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 399 of file OgreResource.h.

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[virtual, inherited]`

Reimplemented in Ogre::SkeletonInstance.

Definition at line 317 of file OgreResource.h.

HardwareBuffer::Usage Ogre::Mesh::getIndexBufferUsage | ( | void |  | ) | const`[inherited]`

Gets the usage setting for this meshes index buffers.

Definition at line 554 of file OgreMesh.h.

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[virtual, inherited]`

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 348 of file OgreResource.h.

ushort Ogre::Mesh::getLodIndex | ( | Real | value | ) | const`[inherited]`

Retrieves the level of detail index for the given lod value.

Note:
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

const MeshLodUsage& Ogre::Mesh::getLodLevel | ( | ushort | index | ) | const`[inherited]`

Gets details of the numbered level of detail entry.

const LodStrategy* Ogre::Mesh::getLodStrategy | ( |  | ) | const`[inherited]`

Get lod strategy used by this mesh.

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const`[virtual, inherited]`

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 312 of file OgreResource.h.

virtual unsigned short Ogre::Mesh::getNumAnimations | ( | void |  | ) | const`[virtual, inherited]`

Gets the number of morph animations in this mesh.

ushort Ogre::Mesh::getNumLodLevels | ( | void |  | ) | const`[inherited]`

Returns the number of levels of detail that this mesh supports.

Remarks:
  This number includes the original model.

unsigned short Ogre::Mesh::getNumSubMeshes | ( | void |  | ) | const`[inherited]`

Gets the number of sub meshes which comprise this mesh.

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[virtual, inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 418 of file OgreResource.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

Pose* Ogre::Mesh::getPose | ( | ushort | index | ) | `[inherited]`

Retrieve an existing Pose by index.

Pose* Ogre::Mesh::getPose | ( | const String & | name | ) | `[inherited]`

Retrieve an existing Pose by name.

size_t Ogre::Mesh::getPoseCount | ( | void |  | ) | const`[inherited]`

Get the number of poses.

Definition at line 855 of file OgreMesh.h.

PoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) | `[inherited]`

Get an iterator over all the poses defined.

ConstPoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) | const`[inherited]`

Get an iterator over all the poses defined.

const PoseList& Ogre::Mesh::getPoseList | ( | void |  | ) | const`[inherited]`

Get pose list.

virtual VertexAnimationType Ogre::Mesh::getSharedVertexDataAnimationType | ( | void |  | ) | const`[virtual, inherited]`

Gets the type of vertex animation the shared vertex data of this mesh supports.

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const`[virtual, inherited]`

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 301 of file OgreResource.h.

const SkeletonPtr& Ogre::Mesh::getSkeleton | ( | void |  | ) | const`[inherited]`

Gets a pointer to any linked Skeleton.

Returns:
  Weak reference to the skeleton - copy this if you want to hold a strong pointer.

const String& Ogre::Mesh::getSkeletonName | ( | void |  | ) | const`[inherited]`

Gets the name of any linked Skeleton.

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const`[virtual, inherited]`

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

Definition at line 429 of file OgreResource.h.

SubMesh* Ogre::Mesh::getSubMesh | ( | unsigned short | index | ) | const`[inherited]`

Gets a pointer to the submesh indicated by the index.

SubMesh* Ogre::Mesh::getSubMesh | ( | const String & | name | ) | const`[inherited]`

Gets a SubMesh by name.

SubMeshIterator Ogre::Mesh::getSubMeshIterator | ( | void |  | ) | `[inherited]`

Gets an iterator over the available submeshes.

Definition at line 273 of file OgreMesh.h.

const SubMeshNameMap& Ogre::Mesh::getSubMeshNameMap | ( | void |  | ) | const`[inherited]`

Gets a reference to the optional name assignments of the SubMeshes.

Definition at line 765 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::getVertexBufferUsage | ( | void |  | ) | const`[inherited]`

Gets the usage setting for this meshes vertex buffers.

Definition at line 552 of file OgreMesh.h.

VertexData* Ogre::Mesh::getVertexDataByTrackHandle | ( | unsigned short | handle | ) | `[inherited]`

Gets a pointer to a vertex data element based on a morph animation track handle.

Remarks:
  0 means the shared vertex data, 1+ means a submesh vertex data (index+1)

virtual bool Ogre::Mesh::hasAnimation | ( | const String & | name | ) | `[virtual, inherited]`

Returns whether this mesh contains the named vertex animation.

bool Ogre::Mesh::hasSkeleton | ( | void |  | ) | const`[inherited]`

Returns true if this Mesh has a linked Skeleton.

bool Ogre::Mesh::hasVertexAnimation | ( | void |  | ) | const`[inherited]`

Returns whether or not this mesh has some kind of vertex animation.

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 365 of file OgreResource.h.

bool Ogre::Mesh::isEdgeListBuilt | ( | void |  | ) | const`[inherited]`

Returns whether this mesh has an attached edge list.

Definition at line 691 of file OgreMesh.h.

bool Ogre::Mesh::isIndexBufferShadowed | ( | void |  | ) | const`[inherited]`

Gets whether or not this meshes index buffers are shadowed.

Definition at line 558 of file OgreMesh.h.

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 332 of file OgreResource.h.

virtual bool Ogre::Resource::isLoading | ( |  | ) | const`[virtual, inherited]`

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 341 of file OgreResource.h.

bool Ogre::Mesh::isLodManual | ( | void |  | ) | const`[inherited]`

Returns true if this mesh is using manual LOD.

Remarks:
  A mesh can either use automatically generated LOD, or it can use alternative meshes as provided by an artist. A mesh can only use either all manual LODs or all generated LODs, not a mixture of both.

Definition at line 493 of file OgreMesh.h.

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[virtual, inherited]`

Is this resource manually loaded?

Definition at line 289 of file OgreResource.h.

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been prepared, false otherwise.

Definition at line 324 of file OgreResource.h.

bool Ogre::Mesh::isPreparedForShadowVolumes | ( | void |  | ) | const`[inherited]`

Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.

Definition at line 688 of file OgreMesh.h.

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 282 of file OgreResource.h.

bool Ogre::Mesh::isVertexBufferShadowed | ( | void |  | ) | const`[inherited]`

Gets whether or not this meshes vertex buffers are shadowed.

Definition at line 556 of file OgreMesh.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::PatchMesh::loadImpl | ( | void |  | ) | `[protected, virtual]`

Overridden from Resource.

Reimplemented from Ogre::Mesh.

void Ogre::Mesh::nameSubMesh | ( | const String & | name,
|  | ushort | index |
| ) |  |  | `[inherited]`

Gives a name to a SubMesh.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

void Ogre::Mesh::organiseTangentsBuffer | ( | VertexData * | vertexData,
|  | VertexElementSemantic | targetSemantic,
|  | unsigned short | index,
|  | unsigned short | sourceTexCoordSet |
| ) |  |  | `[protected, inherited]`

Internal method for making the space for a vertex element to hold tangents.

void Ogre::Mesh::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented from Ogre::Resource.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 199 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 182 of file OgreResource.h.

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters:

  | backgroundThread | Whether this is occurring in a background thread

void Ogre::Mesh::prepareForShadowVolume | ( | void |  | ) | `[inherited]`

This method prepares the mesh for generating a renderable shadow volume.

Remarks:
  Preparing a mesh to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions for the mesh is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers this mesh holds if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version of the mesh. The vertex count of the main VertexData used to render the mesh will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version.

  Because shadow volumes are rendered in turn, no additional index buffer space is allocated by this method, a shared index buffer allocated by the shadow rendering algorithm is used for addressing this extended vertex buffer.

void Ogre::PatchMesh::prepareImpl | ( | void |  | ) | `[protected, virtual]`

Overridden from Resource - do nothing (no disk caching).

Reimplemented from Ogre::Mesh.

Definition at line 77 of file OgrePatchMesh.h.

static void Ogre::Mesh::prepareMatricesForVertexBlend | ( | const Matrix4 ** | blendMatrices,
|  | const Matrix4 * | boneMatrices,
|  | const IndexMap & | indexMap |
| ) |  |  | `[static, inherited]`

Prepare matrices for software indexed vertex blend.

Remarks:
  This function organise bone indexed matrices to blend indexed matrices, so software vertex blending can access to the matrix via blend index directly.

Parameters:

  | blendMatrices | Pointer to an array of matrix pointers to store prepared results, which indexed by blend index
  | boneMatrices | Pointer to an array of matrices to be used to blend, which indexed by bone index
  | indexMap | The index map used to translate blend index to bone index

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 194 of file OgreResource.h.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Mesh::removeAllAnimations | ( | void |  | ) | `[virtual, inherited]`

Removes all morph Animations from this mesh.

void Ogre::Mesh::removeAllPoses | ( | void |  | ) | `[inherited]`

Destroy all poses.

virtual void Ogre::Mesh::removeAnimation | ( | const String & | name | ) | `[virtual, inherited]`

Removes vertex Animation from this mesh.

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Mesh::removeLodLevels | ( | void |  | ) | `[inherited]`

Removes all LOD data from this Mesh.

void Ogre::Mesh::removePose | ( | ushort | index | ) | `[inherited]`

Destroy a pose by index.

Note:
  This will invalidate any animation tracks referring to this pose or those after it.

void Ogre::Mesh::removePose | ( | const String & | name | ) | `[inherited]`

Destroy a pose by name.

Note:
  This will invalidate any animation tracks referring to this pose or those after it.

void Ogre::Mesh::setAutoBuildEdgeLists | ( | bool | autobuild | ) | `[inherited]`

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

Remarks:
  This allows you to create meshes which do not have edge lists calculated, because you never want to use them. This value defaults to 'true' for mesh formats which did not include edge data, and 'false' for newer formats, where edge lists are expected to have been generated in advance.

Definition at line 777 of file OgreMesh.h.

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[virtual, inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 375 of file OgreResource.h.

void Ogre::Mesh::setIndexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false` |
| ) |  |  | `[inherited]`

Sets the policy for the index buffers to be used when loading this Mesh.

Remarks:
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters:

  | usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  | shadowBuffer | If set to true, the index buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

void Ogre::Mesh::setLodStrategy | ( | LodStrategy * | lodStrategy | ) | `[inherited]`

Set the lod strategy used by this mesh.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::Mesh::setSkeletonName | ( | const String & | skelName | ) | `[inherited]`

Sets the name of the skeleton this Mesh uses for animation.

Remarks:
  Meshes can optionally be assigned a skeleton which can be used to animate the mesh through bone assignments. The default is for the Mesh to use no skeleton. Calling this method with a valid skeleton filename will cause the skeleton to be loaded if it is not already (a single skeleton can be shared by many Mesh objects).

Parameters:

  | skelName | The name of the .skeleton file to use, or an empty string to use no skeleton

void Ogre::PatchMesh::setSubdivision | ( | Real | factor | ) |

void Ogre::Mesh::setVertexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false` |
| ) |  |  | `[inherited]`

Sets the policy for the vertex buffers to be used when loading this Mesh.

Remarks:
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters:

  | usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  | shadowBuffer | If set to true, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

static void Ogre::Mesh::softwareVertexBlend | ( | const VertexData * | sourceVertexData,
|  | const VertexData * | targetVertexData,
|  | const Matrix4 *const * | blendMatrices,
|  | size_t | numMatrices,
|  | bool | blendNormals |
| ) |  |  | `[static, inherited]`

Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.

Remarks:
  This function is supplied to update vertex data with blends done in software, either because no hardware support is available, or that you need the results of the blend for some other CPU operations.

Parameters:

  | sourceVertexData | VertexData class containing positions, normals, blend indices and blend weights.
  | targetVertexData | VertexData class containing target position and normal buffers which will be updated with the blended versions. Note that the layout of the source and target position / normal buffers must be identical, ie they must use the same buffer indexes
  | blendMatrices | Pointer to an array of matrix pointers to be used to blend, indexed by blend indices in the sourceVertexData
  | numMatrices | Number of matrices in the blendMatrices, it might be used as a hint for optimisation.
  | blendNormals | If true, normals are blended as well as positions

static void Ogre::Mesh::softwareVertexMorph | ( | Real | t,
|  | const HardwareVertexBufferSharedPtr & | b1,
|  | const HardwareVertexBufferSharedPtr & | b2,
|  | VertexData * | targetVertexData |
| ) |  |  | `[static, inherited]`

Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.

Remarks:
  This function will linearly interpolate positions between two source buffers, into a third buffer.

Parameters:

  | t | Parametric distance between the start and end buffer positions
  | b1 | Vertex buffer containing VET_FLOAT3 entries for the start positions
  | b2 | Vertex buffer containing VET_FLOAT3 entries for the end positions
  | targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

static void Ogre::Mesh::softwareVertexPoseBlend | ( | Real | weight,
|  | const map< size_t, Vector3 >::type & | vertexOffsetMap,
|  | VertexData * | targetVertexData |
| ) |  |  | `[static, inherited]`

Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.

Remarks:
  This function will apply a weighted offset to the positions in the incoming vertex data (therefore this is a read/write operation, and if you expect to call it more than once with the same data, then you would be best to suppress hardware uploads of the position buffer for the duration)

Parameters:

  | weight | Parametric weight to scale the offsets by
  | vertexOffsetMap | Potentially sparse map of vertex index -> offset
  | targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

bool Ogre::Mesh::suggestTangentVectorBuildParams | ( | VertexElementSemantic | targetSemantic,
|  | unsigned short & | outSourceCoordSet,
|  | unsigned short & | outIndex |
| ) |  |  | `[inherited]`

Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents.

Remarks:
  This helper method will suggest source and destination texture coordinate sets for a call to buildTangentVectors. It will detect when there are inappropriate conditions (such as multiple geometry sets which don't agree). Moreover, it will return 'true' if it detects that there are aleady 3D coordinates in the mesh, and therefore tangents may have been prepared already.

Parameters:

  | targetSemantic | The semantic you intend to use to store the tangents if they are not already present; most likely options are VES_TEXTURE_COORDINATES or VES_TANGENT; you should use texture coordinates if you want compatibility with older, pre-SM2 graphics cards, and the tangent binding otherwise.
  | outSourceCoordSet | Reference to a source texture coordinate set which will be populated
  | outIndex | Reference to a destination element index (e.g. texture coord set) which will be populated

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

Referenced by Ogre::Material::touch().

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Mesh::unloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.

Implements Ogre::Resource.

void Ogre::Mesh::unnameSubMesh | ( | const String & | name | ) | `[inherited]`

Removes a name from a SubMesh.

void Ogre::Mesh::unprepareImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Destroys data cached by prepareImpl.

Reimplemented from Ogre::Resource.

void Ogre::Mesh::updateManualLodLevel | ( | ushort | index,
|  | const String & | meshName |
| ) |  |  | `[inherited]`

Changes the alternate mesh to use as a manual LOD at the given index.

Remarks:
  Note that the index of a LOD may change if you insert other LODs. If in doubt, use getLodIndex().

Parameters:

  | index | The index of the level to be changed
  | meshName | The name of the mesh which will be the lower level detail version.

void Ogre::Mesh::updateMaterialForAllSubMeshes | ( | void |  | ) | `[inherited]`

Iterates through all submeshes and requests them to apply their texture aliases to the material they use.

Remarks:
  The submesh will only apply texture aliases to the material if matching texture alias names are found in the material. If a match is found, the submesh will automatically clone the original material and then apply its texture to the new material.

  This method is normally called by the protected method loadImpl when a mesh if first loaded.

## Member Data Documentation

AxisAlignedBox Ogre::Mesh::mAABB`[protected, inherited]`

Local bounding box volume.

Definition at line 136 of file OgreMesh.h.

AnimationList Ogre::Mesh::mAnimationsList`[protected, inherited]`

Definition at line 176 of file OgreMesh.h.

bool Ogre::Mesh::mAnimationTypesDirty`[mutable, protected, inherited]`

Do we need to scan animations for animation types?

Definition at line 180 of file OgreMesh.h.

bool Ogre::Mesh::mAutoBuildEdgeLists`[protected, inherited]`

Definition at line 172 of file OgreMesh.h.

VertexBoneAssignmentList Ogre::Mesh::mBoneAssignments`[protected, inherited]`

Definition at line 145 of file OgreMesh.h.

bool Ogre::Mesh::mBoneAssignmentsOutOfDate`[protected, inherited]`

Flag indicating that bone assignments need to be recompiled.

Definition at line 148 of file OgreMesh.h.

Real Ogre::Mesh::mBoundRadius`[protected, inherited]`

Local bounding sphere radius (centered on object).

Definition at line 138 of file OgreMesh.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

Creator.

Definition at line 142 of file OgreResource.h.

VertexDeclaration* Ogre::PatchMesh::mDeclaration`[protected]`

Vertex declaration, cloned from the input.

Definition at line 53 of file OgrePatchMesh.h.

bool Ogre::Mesh::mEdgeListsBuilt`[protected, inherited]`

Definition at line 171 of file OgreMesh.h.

DataStreamPtr Ogre::Mesh::mFreshFromDisk`[protected, inherited]`

Definition at line 131 of file OgreMesh.h.

String Ogre::Resource::mGroup`[protected, inherited]`

The name of the resource group.

Definition at line 146 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

Numeric handle for more efficient look up than name.

Definition at line 148 of file OgreResource.h.

bool Ogre::Mesh::mIndexBufferShadowBuffer`[protected, inherited]`

Definition at line 167 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::mIndexBufferUsage`[protected, inherited]`

Definition at line 165 of file OgreMesh.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

Is this resource going to be background loaded? Only applicable for multithreaded.

Definition at line 152 of file OgreResource.h.

bool Ogre::Mesh::mIsLodManual`[protected, inherited]`

Definition at line 160 of file OgreMesh.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

Is this file manually loaded?

Definition at line 156 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

Definition at line 165 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

Optional manual loader; if provided, data is loaded from here instead of a file.

Definition at line 160 of file OgreResource.h.

AtomicScalar<LoadingState> Ogre::Resource::mLoadingState`[protected, inherited]`

Is the resource currently loaded?

Definition at line 150 of file OgreResource.h.

const LodStrategy* Ogre::Mesh::mLodStrategy`[protected, inherited]`

Definition at line 159 of file OgreMesh.h.

MeshLodUsageList Ogre::Mesh::mMeshLodUsageList`[protected, inherited]`

Definition at line 162 of file OgreMesh.h.

String Ogre::Resource::mName`[protected, inherited]`

Unique name of the resource.

Definition at line 144 of file OgreResource.h.

ushort Ogre::Mesh::mNumLods`[protected, inherited]`

Definition at line 161 of file OgreMesh.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

Origin of this resource (e.g. script name) - optional.

Definition at line 158 of file OgreResource.h.

PoseList Ogre::Mesh::mPoseList`[protected, inherited]`

List of available poses for shared and dedicated geometryPoseList.

Definition at line 183 of file OgreMesh.h.

bool Ogre::Mesh::mPreparedForShadowVolumes`[protected, inherited]`

Definition at line 170 of file OgreMesh.h.

VertexAnimationType Ogre::Mesh::mSharedVertexDataAnimationType`[mutable, protected, inherited]`

The vertex animation type associated with the shared vertex data.

Definition at line 178 of file OgreMesh.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

The size of the resource in bytes.

Definition at line 154 of file OgreResource.h.

SkeletonPtr Ogre::Mesh::mSkeleton`[protected, inherited]`

Definition at line 142 of file OgreMesh.h.

String Ogre::Mesh::mSkeletonName`[protected, inherited]`

Optional linked skeleton.

Definition at line 141 of file OgreMesh.h.

size_t Ogre::Resource::mStateCount`[protected, inherited]`

State count, the number of times this resource has changed state.

Definition at line 162 of file OgreResource.h.

SubMeshList Ogre::Mesh::mSubMeshList`[protected, inherited]`

A list of submeshes which make up this mesh.

Each mesh is made up of 1 or more submeshes, which are each based on a single material and can have their own vertex data (they may not - they can share vertex data from the Mesh, depending on preference).

Definition at line 115 of file OgreMesh.h.

SubMeshNameMap Ogre::Mesh::mSubMeshNameMap`[protected, inherited]`

Definition at line 133 of file OgreMesh.h.

PatchSurface Ogre::PatchMesh::mSurface`[protected]`

Internal surface definition.

Definition at line 51 of file OgrePatchMesh.h.

bool Ogre::Mesh::mVertexBufferShadowBuffer`[protected, inherited]`

Definition at line 166 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::mVertexBufferUsage`[protected, inherited]`

Definition at line 164 of file OgreMesh.h.

IndexMap Ogre::Mesh::sharedBlendIndexToBoneIndexMap`[inherited]`

Shared index map for translating blend index to bone index.

Remarks:
  This index map can be shared among multiple submeshes. SubMeshes might not have their own IndexMap, they might share this one.

  We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire Mesh.

  Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index.

  The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format.

Definition at line 306 of file OgreMesh.h.

VertexData* Ogre::Mesh::sharedVertexData`[inherited]`

Shared vertex data.

Remarks:
  This vertex data can be shared among multiple submeshes. SubMeshes may not have their own VertexData, they may share this one.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

Definition at line 284 of file OgreMesh.h.

The documentation for this class was generated from the following file:

- OgrePatchMesh.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:58